package kr.co.heliopolis.msgnotifications;

import android.app.Notification;
import android.content.Intent;
import android.os.Bundle;
import android.service.notification.NotificationListenerService;
import android.service.notification.StatusBarNotification;
import android.util.Log;


/**
 * Notification listening service. Intercepts notifications if permission is given to do so.
 */
public class NotificationListener extends NotificationListenerService {

    public static String NOTIFICATION_INTENT = "notification_event";
    public static String NOTIFICATION_PACKAGE_NAME = "package_name";
    public static String NOTIFICATION_MESSAGE = "message";
    public static String NOTIFICATION_TITLE = "title";
    public static String NOTIFICATION_TICKER = "ticker";

    @Override
    public void onNotificationPosted(StatusBarNotification sbn) {

        String packageName = sbn.getPackageName();
        Log.i(NOTIFICATION_PACKAGE_NAME, packageName);
        if ("com.google.android.apps.messaging".equals(packageName)) {
            Notification notification = sbn.getNotification();
            Log.i("aa", notification.toString());
            String ticker = "";
            Bundle extras;
            String title = "";
            String text = "";
            if (notification != null) {
                if (notification.tickerText != null) {
                    ticker = sbn.getNotification().tickerText.toString();
                }
                extras = sbn.getNotification().extras;
                if (extras != null) {
                    title = extras.getString("android.title");
                    text = extras.getCharSequence("android.text").toString();
                }

                Intent msgrcv = new Intent(NOTIFICATION_INTENT);
                msgrcv.putExtra(NOTIFICATION_PACKAGE_NAME, packageName);
                msgrcv.putExtra(NOTIFICATION_TICKER, ticker);
                msgrcv.putExtra(NOTIFICATION_TITLE, title);
                msgrcv.putExtra(NOTIFICATION_MESSAGE, text);

                sendBroadcast(msgrcv);
            }

            Log.i(NOTIFICATION_TICKER, ticker);
            Log.i(NOTIFICATION_TITLE, title);
            Log.i(NOTIFICATION_MESSAGE, text);
        }
    }
}